-------------------------------------------------------------------------------
--
-- The Black and Gold Shells! Here's and explosive kick!
-- A Jana Sol Script
-- Sprites and icons are my own
-------------------------------------------------------------------------------
/*
--item flags, people making custom items can copy/paste this over to their lua scripts
local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon and dropped item frame changes depending on the item amount (animation frames become amount frames)

local XBT_ATTACKDISABLED = 1<<7

freeslot(
	"MT_BLACKSHELL",
	"SPR_BSHL",
	"S_BLACKSHELL",
	"MT_GOLDSHELL",
	"SPR_GSHL",
	"S_GOLDSHELL",
	"sfx_shroll"
)

mobjinfo[MT_BLACKSHELL] = {
	spawnstate = S_BLACKSHELL,
	spawnhealth = 1,
	radius = 24*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_MISSILE|MF_DONTENCOREMAP
}

states[S_BLACKSHELL] = {
	sprite = SPR_BSHL,
	frame = FF_ANIMATE|A,
	tics = -1,
	action = nil,
	var1 = 5,
	var2 = 1,
	nextstate = S_NULL
}

mobjinfo[MT_GOLDSHELL] = {
	spawnstate = S_GOLDSHELL,
	spawnhealth = 1,
	radius = 24*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_MISSILE|MF_DONTENCOREMAP
}

states[S_GOLDSHELL] = {
	sprite = SPR_BSHL,
	frame = FF_ANIMATE|A,
	tics = -1,
	action = nil,
	var1 = 5,
	var2 = 1,
	nextstate = S_NULL
}

sfxinfo[sfx_shroll] = {
        singular = false,
        priority = 64,
        flags = SF_X2AWAYSOUND
}

local function useBlackShell (player, cmd)
	player.kartstuff[k_itemamount] = $-1
	local spawndist = 128*mapobjectscale
	local throwspeed = 256*mapobjectscale
	local spawnoffx = FixedMul(spawndist, cos(player.mo.angle))
	local spawnoffy = FixedMul(spawndist, sin(player.mo.angle))
	local throwspdx = FixedMul(throwspeed, cos(player.mo.angle))
	local throwspdy = FixedMul(throwspeed, sin(player.mo.angle))
	local shell
	if player.kartstuff[k_throwdir] then
		if player.kartstuff[k_throwdir] == -1 then
			shell = P_SpawnMobj(player.mo.x - spawnoffx, player.mo.y - spawnoffy, player.mo.z, MT_BLACKSHELL)
			shell.momx = -throwspdx/2
			shell.momy = -throwspdy/2
			shell.target = player.mo
		else
			shell = P_SpawnMobj(player.mo.x + spawnoffx, player.mo.y + spawnoffy, player.mo.z, MT_BLACKSHELL)
			shell.momx = throwspdx + player.mo.momx
			shell.momy = throwspdy + player.mo.momy
			shell.target = player.mo
		end
	else
		shell = P_SpawnMobj(player.mo.x + spawnoffx, player.mo.y + spawnoffy, player.mo.z, MT_BLACKSHELL)
		shell.momx = throwspdx + player.mo.momx
		shell.momy = throwspdy + player.mo.momy
		shell.target = player.mo
	end
	S_StartSound(player.mo, sfx_tossed)
end

addHook("MobjThinker", function(mobj)
	if not S_SoundPlaying(mobj, sfx_shroll) then S_StartSound(mobj, sfx_shroll) end
	local collision, filler
	for i = 0, 15 do
		local mobjzmom = mobj.momz
		mobj.momz = 0
		collision, filler = P_TryMove(mobj, mobj.x + FixedDiv(mobj.momx, FRACUNIT*15), mobj.y + FixedDiv(mobj.momy, FRACUNIT*15), true)
		if collision == false
			P_RemoveMobj(mobj)
			return
		end
		mobj.momz = mobjzmom
	end
end, MT_BLACKSHELL)

addHook("MobjRemoved", function(mobj)
	K_SpawnMineExplosion(mobj, SKINCOLOR_BLACK)
	local explodedist = FixedMul( (3 * (192 * FRACUNIT) ) / 2, mapobjectscale)
	for i = 0, 15 do
		K_SpawnKartExplosion(mobj.x, mobj.y, mobj.z, explodedist + (32 * mapobjectscale), 32, MT_MINEEXPLOSION, i * (ANGLE_45 / 4), true, false, nil)
	end
end, MT_BLACKSHELL)

addHook("MobjDamage", function(target, mo, source)
	if mo and mo.valid and target.player then
		if mo.type ~= MT_BLACKSHELL then return end
		K_ExplodePlayer(target.player, mo, mo.target)
	end
end, MT_PLAYER)

xItemLib.func.addItem(
    "FKB_BLACKSHELL",
    "Black Shell",
    {35, "K_ITBSH1", "K_ITBSH2", "K_ITBSH3"},
    "K_ISBSHL",
    XIF_ICONFORAMT,
    {10, 10, 10, 10, 10, 10, 10, 10, 10, 10},
    {10, 10},
    nil,
    useBlackShell,
    nil,
    nil,
    nil,
    {0, {SPR_FKIT, 5}},
	true,
    nil,
    nil
)

local function getTripleBlackShell(p, i)
	return xItemLib.xItemNamespaces["FKB_BLACKSHELL"], 3
end

xItemLib.func.addItem(
    "FKB_TRIPLEBLACKSHELL",
    "Triple Black Shell",
    "K_ITBSH3",
    "K_ISBSHL",
    XIF_POWERITEM,
    {10, 10, 10, 10, 10, 10, 10, 10, 10, 10},
    {10, 10},
    nil,
    nil,
    nil,
    nil,
    getTripleBlackShell,
    {0, {SPR_FKIT, 5}},
	true,
    nil,
    nil
)

local function useGoldShell (player, cmd)
	player.kartstuff[k_itemamount] = $-1
	local spawndist = 128*mapobjectscale
	local throwspeed = 32*mapobjectscale
	local spawnoffx = FixedMul(spawndist, cos(player.mo.angle))
	local spawnoffy = FixedMul(spawndist, sin(player.mo.angle))
	local throwspdx = FixedMul(throwspeed, cos(player.mo.angle))
	local throwspdy = FixedMul(throwspeed, sin(player.mo.angle))
	local shell
	if player.kartstuff[k_throwdir] then
		if player.kartstuff[k_throwdir] == -1 then
			shell = P_SpawnMobj(player.mo.x - spawnoffx, player.mo.y - spawnoffy, player.mo.z, MT_BLACKSHELL)
			shell.momx = -throwspdx/2
			shell.momy = -throwspdy/2
			shell.target = player.mo
		else
			shell = P_SpawnMobj(player.mo.x + spawnoffx, player.mo.y + spawnoffy, player.mo.z, MT_BLACKSHELL)
			shell.momx = throwspdx + player.mo.momx
			shell.momy = throwspdy + player.mo.momy
			shell.target = player.mo
		end
	else
		shell = P_SpawnMobj(player.mo.x + spawnoffx, player.mo.y + spawnoffy, player.mo.z, MT_BLACKSHELL)
		shell.momx = throwspdx + (player.mo.momx or 0)
		shell.momy = throwspdy + player.mo.momy or 0
		shell.target = player.mo
	end
	S_StartSound(player.mo, sfx_tossed)
end
*/