-------------------------------------------------------------------------------
--
-- The Force Shield! Here's your kart insurance!
-- A Jana Sol Script
-- Sprites for the shield come from SRB2 and STjr, icon sprites are my own
-------------------------------------------------------------------------------

freeslot(
	"MT_CRYSTALSHIELD",
	"MT_CRYSTALHALFFX",
	"MT_CRYSTALFULLFX",
	"SPR_FORC",
	"S_CRYSTALFULL",
	"S_CRYSTALFULL5",
	"S_CRYSTALFULL4",
	"S_CRYSTALFULL3",
	"S_CRYSTALFULL2",
	"S_CRYSTALFULL1",
	"S_CRYSTALHALF",
	"S_CRYSTALHALF2",
	"S_CRYSTALHALF1",
	"sfx_cryssg",
	"sfx_cystsg",
	"sfx_crysls"
)

mobjinfo[MT_CRYSTALSHIELD] = {
	spawnstate = S_CRYSTALFULL,
	spawnhealth = 1,
	dispoffset = 1,
	radius = 32*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SCENERY|MF_NOCLIPTHING
}

mobjinfo[MT_CRYSTALFULLFX] = {
	spawnstate = S_CRYSTALFULL5,
	spawnhealth = 1,
	dispoffset = 1,
	radius = 32*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SCENERY|MF_NOCLIPTHING
}

mobjinfo[MT_CRYSTALHALFFX] = {
	spawnstate = S_CRYSTALHALF2,
	spawnhealth = 1,
	dispoffset = 1,
	radius = 32*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SCENERY|MF_NOCLIPTHING
}

states[S_CRYSTALFULL] = {
	sprite = SPR_FORC,
	frame = TR_TRANS50|FF_ANIMATE|A,
	tics = -1,
	action = nil,
	var1 = 9,
	var2 = 3,
	nextstate = S_NULL
}

states[S_CRYSTALFULL5] = {
	sprite = SPR_FORC,
	frame = TR_TRANS50|A,
	tics = 1,
	action = nil,
	var1 = 9,
	var2 = 3,
	nextstate = S_CRYSTALFULL4
}

states[S_CRYSTALFULL4] = {
	sprite = SPR_FORC,
	frame = TR_TRANS60|B,
	tics = 1,
	action = nil,
	var1 = 9,
	var2 = 3,
	nextstate = S_CRYSTALFULL3
}

states[S_CRYSTALFULL3] = {
	sprite = SPR_FORC,
	frame = TR_TRANS70|C,
	tics = 1,
	action = nil,
	var1 = 9,
	var2 = 3,
	nextstate = S_CRYSTALFULL2
}

states[S_CRYSTALFULL2] = {
	sprite = SPR_FORC,
	frame = TR_TRANS80|D,
	tics = 1,
	action = nil,
	var1 = 9,
	var2 = 3,
	nextstate = S_CRYSTALFULL1
}

states[S_CRYSTALFULL1] = {
	sprite = SPR_FORC,
	frame = TR_TRANS90|E,
	tics = 1,
	action = nil,
	var1 = 9,
	var2 = 3,
	nextstate = S_NULL
}

states[S_CRYSTALHALF] = {
	sprite = SPR_FORC,
	frame = TR_TRANS80|FF_ANIMATE|K,
	tics = -1,
	action = nil,
	var1 = 9,
	var2 = 3,
	nextstate = S_NULL
}

states[S_CRYSTALHALF2] = {
	sprite = SPR_FORC,
	frame = TR_TRANS80|FF_ANIMATE|K,
	tics = 2,
	action = nil,
	var1 = 9,
	var2 = 1,
	nextstate = S_CRYSTALHALF1
}

states[S_CRYSTALHALF1] = {
	sprite = SPR_FORC,
	frame = TR_TRANS90|FF_ANIMATE|M,
	tics = 3,
	action = nil,
	var1 = 9,
	var2 = 1,
	nextstate = S_NULL
}

S_sfx[sfx_cryssg] = {
	singular = false,
	priority = 255,
	flags = SF_X8AWAYSOUND
}

S_sfx[sfx_cystsg] = {
	singular = false,
	priority = 255,
	flags = 0
}

S_sfx[sfx_crysls] = {
	singular = false,
	priority = 255,
	flags = SF_X8AWAYSOUND
}
local function hitShield(mo)
	mo.target.player.fkbcrystalshieldfx = P_SpawnMobj(mo.target.x, mo.target.y, mo.target.z, MT_CRYSTALFULLFX)
	
	mo.target.player.fkbcrystalshieldfx.fuse = 5
	mo.target.player.fkbcrystalshieldfx.scalespeed = FRACUNIT/2
	mo.target.player.fkbcrystalshieldfx.destscale = 4*FRACUNIT
	mo.target.player.fkbcrystalshieldfx.target = mo.target
end

local function despawnShield(mo)
	mo.target.player.fkbcrystalshieldfx = P_SpawnMobj(mo.target.x, mo.target.y, mo.target.z, MT_CRYSTALHALFFX)
	
	mo.target.player.fkbcrystalshieldfx.fuse = 5
	mo.target.player.fkbcrystalshieldfx.scalespeed = FRACUNIT/2
	mo.target.player.fkbcrystalshieldfx.destscale = 4*FRACUNIT
	mo.target.player.fkbcrystalshieldfx.target = mo.target
	
	P_RemoveMobj(mo)
end

addHook("MobjThinker", function(mo)
    if mo.target.valid
		P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
	else
		P_RemoveMobj(mo)
	end
end, MT_CRYSTALFULLFX)

addHook("MobjThinker", function(mo)
    if mo.target.valid
		P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
	else
		P_RemoveMobj(mo)
	end
end, MT_CRYSTALHALFFX)

addHook("MobjThinker", function(mobj)
	P_MoveOrigin(mobj, mobj.target.x, mobj.target.y, mobj.target.z)
	mobj.scale = mobj.target.scale
	if mobj.target.player.playerstate == 1
		P_RemoveMobj(mobj)
		return
	end
end, MT_CRYSTALSHIELD)

addHook("ShouldSpin", function(player, inflictor, source)
	if not player.fkbcrystalshield.valid then return end
	if player.fkbcrystalshield.state == S_CRYSTALFULL
		player.kartstuff[k_invincibilitytimer] = 1
		player.powers[pw_flashing] = 70
		S_StartSound(player.mo, sfx_crysls)
		player.fkbcrystalshield.state = S_CRYSTALHALF
		hitShield(player.fkbcrystalshield)
	elseif player.fkbcrystalshield.state == S_CRYSTALHALF
		player.kartstuff[k_invincibilitytimer] = 1
		player.powers[pw_flashing] = 70
		S_StartSound(player.mo, sfx_crysls)
		despawnShield(player.fkbcrystalshield)
	end
end)

addHook("ShouldExplode", function(player, inflictor, source)
	if not player.fkbcrystalshield.valid then return end
	if source.type == MT_SPBEXPLOSION and source.extravalue1 == 1 then
		despawnShield(player.fkbcrystalshield)
		return
	end
	if player.fkbcrystalshield.state == S_CRYSTALFULL
		player.kartstuff[k_invincibilitytimer] = 1
		player.powers[pw_flashing] = 70
		S_StartSound(player.mo, sfx_crysls)
		player.fkbcrystalshield.state = S_CRYSTALHALF
		hitShield(player.fkbcrystalshield)
	elseif player.fkbcrystalshield.state == S_CRYSTALHALF
		player.kartstuff[k_invincibilitytimer] = 1
		player.powers[pw_flashing] = 70
		S_StartSound(player.mo, sfx_crysls)
		despawnShield(player.fkbcrystalshield)
	end
end)

addHook("ShouldSquish", function(player, inflictor, source)
	if not player.fkbcrystalshield.valid then return end
	if player.fkbcrystalshield.state == S_CRYSTALFULL
		player.kartstuff[k_invincibilitytimer] = 1
		player.powers[pw_flashing] = 70
		S_StartSound(player.mo, sfx_crysls)
		player.fkbcrystalshield.state = S_CRYSTALHALF
		hitShield(player.fkbcrystalshield)
	elseif player.fkbcrystalshield.state == S_CRYSTALHALF
		player.kartstuff[k_invincibilitytimer] = 1
		player.powers[pw_flashing] = 70
		S_StartSound(player.mo, sfx_crysls)
		despawnShield(player.fkbcrystalshield)
	end
end)

local function useCrys(player, cmd)
	player.kartstuff[k_itemamount] = $-1
	if player.fkbcrystalshield ~= nil
		if player.fkbcrystalshield.valid 
			player.fkbcrystalshield.state = S_CRYSTALFULL
			S_StartSound(player.mo, sfx_cryssg)
			S_StartSound(player.mo, sfx_cystsg)
			return
		end 
	end
	player.fkbcrystalshield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_CRYSTALSHIELD)
	S_StartSound(player.mo, sfx_cryssg)
	S_StartSound(player.mo, sfx_cystsg)
	player.fkbcrystalshield.target = player.mo
end


xItemLib.func.addItem(
    "FKB_CRYSTALSHIELD",
    "Force Shield",
    "K_ITCRYS",
    "K_ISCRYS",
    0,
    {10, 10, 10, 10, 10, 10, 10, 10, 10, 10},
    {10, 10},
    nil,
    useCrys,
    nil,
    nil,
    nil,
    {0, {SPR_FKIT, 4}},
	true,
    nil,
    nil
)