-------------------------------------------------------------------------------
--
-- FKB's Custom HUD: Jana Sol with parts from DirkTheHusky
--
-------------------------------------------------------------------------------

rawset(_G, "fkb_check", true)
rawset(_G, "fkb_hud", true)

COM_AddCommand("FKB_EnhancedCheck", function(player, arg, suppress) --This is because you wanted it Mylo. The rest of it wont be toggleable. Suffer :) Its my mod
	if arg == "on" or arg == "1" or arg == "true"
		if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "CHECK Enhancements on.")
			end
			fkb_check = true
		end
	 elseif arg == "off" or arg == "0" or arg == "false"
        if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "CHECK Enhancements off.")
			end
			fkb_check = false
        end
	elseif arg == "notext" or arg == 2 or arg == "performance" or arg == "tryhard_mode"
		if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "CHECK Enhancements Performance Mode.")
			end
			fkb_check = notext
        end
	end
end)

COM_AddCommand("FKB_HUD", function(player, arg, suppress) --This is because you wanted it Mylo. The rest of it wont be toggleable. Suffer :) Its my mod
	if arg == "on" or arg == "1" or arg == "true"
		if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "HUD Enhancements on.")
			end
			fkb_hud = true
		end
	 elseif arg == "off" or arg == "0" or arg == "false"
        if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "HUD Enhancements off.")
			end
			fkb_hud = false
        end
	end
end)

addHook("ThinkFrame", do
	for p in players.iterate do
		--More dirk code :)
		if p.laptimer == nil
			p.laptimer = 0
		end
		if p.lapsavetime == nil or p.spectator
			p.lapsavetime = 0
		end
		if p.realtime > 0
			p.laptimer = $+1
			p.lapsaved = false
			if not p.kartstuff[k_lapanimation]
				p.lapsavetime = $+1
			end
		else
			p.laptimer = 0
			p.lapsavetime = 0
			p.lapsaved = false
		end
		if p.kartstuff[k_lapanimation]
			if p.kartstuff[k_lapanimation] == 80
				p.lapsavetime = p.laptimer
				p.laptimer = 0
			end
			p.lapsaved = true
		else
			p.lapsaved = false
			p.lapsavetime = 0
		end
		
		--Heres non-Dirk Code
		p.trueoldplacement = $ or 0
		p.timesinceposchange = $ or 1
		p.lastticklapcount = $ or 0
		p.deltadispticks = $ or 0
		p.lapslasttick = $ or 0
		if p.deltadispticks > 0 then p.deltadispticks = $-1 end
		p.numberpref = 1
		if p.timesinceposchange < 5 then p.timesinceposchange = $ + 1 end
		if p.kartstuff[k_position] != p.trueoldplacement
			p.timesinceposchange = 1
		end
		if p.kartstuff[k_position] < p.trueoldplacement then S_StartSound(nil, sfx_plcupb, p) end
		if p.kartstuff[k_position] > p.trueoldplacement then S_StartSound(nil, sfx_plcdnb, p) end
		if p.lapslasttick ~= p.laps
			local otherPlayerTime
			local lapdelta
			p.timecomplap = p.realtime
			if p.kartstuff[k_position] ~= 1
				for p2 in players.iterate do
					if p2.kartstuff[k_position] == p.kartstuff[k_position] - 1 and p2 ~= p
						otherPlayerTime = p2.timecomplap
						lapdelta = p2.laps - p.laps
					end
				end
				p.lapdelta = lapdelta
				p.timedelta = p.timecomplap - otherPlayerTime
				if p.kartstuff[k_position] == 2
					for p2 in players.iterate do
						if p2.kartstuff[k_position] == 1 and p2 ~= p
							p2.timedelta = p.timedelta
							p2.lapdelta = lapdelta
							p2.deltadispticks = 70
						end
					end
				end
				p.deltadispticks = 70
			end
		end
		--CONS_Printf(p, p.timesinceposchange)
		p.trueoldplacement = p.kartstuff[k_position]
		p.lapslasttick = p.laps
	end
end)

-------------------------------------------------------------------------------
--
-- New Check Markers: Jana Sol
--(I hate converting C to Lua. This was a mistake)
-------------------------------------------------------------------------------

local CHEK_Y = 200 - 26

local function FKB_K_FindCheckX(px, py, ang, mx, my)
	local dist, x
	local range = RING_DIST/3
	local diff

	range = $*(CV_FindVar("kartspeed").value+1)

	dist = abs(R_PointToDist2(px, py, mx, my))
	if (dist > range) then
		return -3200
	end
	--print("Dist check")
	diff = R_PointToAngle2(px, py, mx, my) - ang

	if (diff < ANGLE_90 and diff > ANGLE_270)
		return -3200
	else
		x = (FixedMul(tan(diff, true), 160<<FRACBITS)+ (160<<FRACBITS))>>FRACBITS
	end
	--print("Diff check")
	if (CV_FindVar("kartencore").value == 1)
		x = 320-x
	end
	return x
end

local function drawNewPlayerCheck(v, p)
	local x
	local xscaleint,xscalefixed = v.dupx()
	local yscaleint,yscalefixed = v.dupy()
	--print(xscaleint, xscalefixed)
	--print(yscaleint, yscalefixed)
	--print(CV_FindVar("kartencore").value)
	local flags = V_SNAPTOBOTTOM
	if p.spectator
	or splitscreen
		return
	end
	
	if not (p.splitscreenindex == 0 and gametype == GT_RACE and fkb_check ~= false)
		hud.enable("check")
		return 
	end
	hud.disable("check")
	for p2 in players.iterate do
		if p == p2 then continue end
		if not p2.mo then continue end
		if not p.mo then continue end
		x = FKB_K_FindCheckX(p.mo.x, p.mo.y, p.mo.angle, p2.mo.x, p2.mo.y)
		--print("Value Returned")
		--print(x)
		if (/*x <= 420 and*/ x >= 0) then
			/*if (x < 14)
				x = 14
			elseif (x > 306)
				x = 306
			end*/
			--print("x is good")
			local color = v.getColormap(TC_DEFAULT, p2.mo.color)
			local patch = v.cachePatch(skins[p2.mo.skin].facewant) --skins[p2.mo.skin].facemmap
			v.drawScaled((x - 13)*FRACUNIT, CHEK_Y*FRACUNIT, 3*FRACUNIT/4, patch, V_HUDTRANS|V_SNAPTOBOTTOM, color)
			if fkb_check ~= notext then
				local textoffset = v.stringWidth(p2.name, V_HUDTRANS|V_SNAPTOBOTTOM, "thin")/2
				if x > 20000 then 
					textoffset = (x - 65535) - $ 
				else
					textoffset = x - $
				end
				v.drawString(textoffset, CHEK_Y - 12, p2.name, V_HUDTRANS|V_SNAPTOBOTTOM, "thin")
				if p2.kartstuff[k_invincibilitytimer] > 0
					v.drawScaled((x - 13)*FRACUNIT, CHEK_Y*FRACUNIT, 1*FRACUNIT/2, v.cachePatch("K_ITINV1"), V_HUDTRANSHALF|V_SNAPTOBOTTOM)
				end
				if p2.kartstuff[k_growshrinktimer] > 0
					v.drawScaled((x - 13)*FRACUNIT, CHEK_Y*FRACUNIT, 1*FRACUNIT/2, v.cachePatch("K_ITGROW"), V_HUDTRANSHALF|V_SNAPTOBOTTOM)
				end
				-- do another one of these for super when retrostation gives you the shit
				if p2.HMRs then
					local restatSpatch = v.cachePatch("OPPRNK0"..tostring(p2.HMRs))
					local restatWpatch = v.cachePatch("OPPRNK0"..tostring(p2.HMRw))
					v.draw(x - 16, CHEK_Y, restatSpatch, V_HUDTRANS|V_SNAPTOBOTTOM)
					v.draw(x + 4, CHEK_Y + 16, restatWpatch, V_HUDTRANS|V_SNAPTOBOTTOM)
				end
			end
			--v.draw(x, CHEK_Y, patch, V_HUDTRANS|V_SNAPTOBOTTOM, color)
		end
	end
end

hud.add(drawNewPlayerCheck, "game")

-------------------------------------------------------------------------------
--
-- New Positions: Jana Sol
--
-------------------------------------------------------------------------------

freeslot("sfx_plcupb", "sfx_plcdnb")

sfxinfo[sfx_plcupb] = {
        singular = false,
        priority = 64,
        flags = SF_TOTALLYSINGLE 
}

sfxinfo[sfx_plcdnb] = {
        singular = false,
        priority = 64,
        flags = SF_TOTALLYSINGLE 
}

local function DynPosition(v, p)
	-- Big ass patch wall here, dont mind this
	
	--setup vars
	local xoffset = 0
	local yoffset = 5
	local placementflags = V_SNAPTOTOP|V_SNAPTOLEFT|V_HUDTRANS
	--1st place patches MK
	local MKPOS01A = v.cachePatch("MKPOS01A")
	local MKPOS01B = v.cachePatch("MKPOS01B")
	local MKPOS01C = v.cachePatch("MKPOS01C")
	local MKPOS01D = v.cachePatch("MKPOS01D")
	local MKPOS01E = v.cachePatch("MKPOS01E")
	--2nd place patches MK
	local MKPOS02A = v.cachePatch("MKPOS02A")
	local MKPOS02B = v.cachePatch("MKPOS02B")
	local MKPOS02C = v.cachePatch("MKPOS02C")
	local MKPOS02D = v.cachePatch("MKPOS02D")
	local MKPOS02E = v.cachePatch("MKPOS02E")
	--3rd place patches MK
	local MKPOS03A = v.cachePatch("MKPOS03A")
	local MKPOS03B = v.cachePatch("MKPOS03B")
	local MKPOS03C = v.cachePatch("MKPOS03C")
	local MKPOS03D = v.cachePatch("MKPOS03D")
	local MKPOS03E = v.cachePatch("MKPOS03E")
	--4th place patches MK
	local MKPOS04A = v.cachePatch("MKPOS04A")
	local MKPOS04B = v.cachePatch("MKPOS04B")
	local MKPOS04C = v.cachePatch("MKPOS04C")
	local MKPOS04D = v.cachePatch("MKPOS04D")
	local MKPOS04E = v.cachePatch("MKPOS04E")
	--5th place patches MK
	local MKPOS05A = v.cachePatch("MKPOS05A")
	local MKPOS05B = v.cachePatch("MKPOS05B")
	local MKPOS05C = v.cachePatch("MKPOS05C")
	local MKPOS05D = v.cachePatch("MKPOS05D")
	local MKPOS05E = v.cachePatch("MKPOS05E")
	--6th place patches MK
	local MKPOS06A = v.cachePatch("MKPOS06A")
	local MKPOS06B = v.cachePatch("MKPOS06B")
	local MKPOS06C = v.cachePatch("MKPOS06C")
	local MKPOS06D = v.cachePatch("MKPOS06D")
	local MKPOS06E = v.cachePatch("MKPOS06E")
	--7th place patches MK
	local MKPOS07A = v.cachePatch("MKPOS07A")
	local MKPOS07B = v.cachePatch("MKPOS07B")
	local MKPOS07C = v.cachePatch("MKPOS07C")
	local MKPOS07D = v.cachePatch("MKPOS07D")
	local MKPOS07E = v.cachePatch("MKPOS07E")
	--8th place patches MK
	local MKPOS08A = v.cachePatch("MKPOS08A")
	local MKPOS08B = v.cachePatch("MKPOS08B")
	local MKPOS08C = v.cachePatch("MKPOS08C")
	local MKPOS08D = v.cachePatch("MKPOS08D")
	local MKPOS08E = v.cachePatch("MKPOS08E")
	--9th place patches MK
	local MKPOS09A = v.cachePatch("MKPOS09A")
	local MKPOS09B = v.cachePatch("MKPOS09B")
	local MKPOS09C = v.cachePatch("MKPOS09C")
	local MKPOS09D = v.cachePatch("MKPOS09D")
	local MKPOS09E = v.cachePatch("MKPOS09E")
	--10th place patches MK
	local MKPOS10A = v.cachePatch("MKPOS10A")
	local MKPOS10B = v.cachePatch("MKPOS10B")
	local MKPOS10C = v.cachePatch("MKPOS10C")
	local MKPOS10D = v.cachePatch("MKPOS10D")
	local MKPOS10E = v.cachePatch("MKPOS10E")
	--11th place patches MK
	local MKPOS11A = v.cachePatch("MKPOS11A")
	local MKPOS11B = v.cachePatch("MKPOS11B")
	local MKPOS11C = v.cachePatch("MKPOS11C")
	local MKPOS11D = v.cachePatch("MKPOS11D")
	local MKPOS11E = v.cachePatch("MKPOS11E")
	--12th place patches MK
	local MKPOS12A = v.cachePatch("MKPOS12A")
	local MKPOS12B = v.cachePatch("MKPOS12B")
	local MKPOS12C = v.cachePatch("MKPOS12C")
	local MKPOS12D = v.cachePatch("MKPOS12D")
	local MKPOS12E = v.cachePatch("MKPOS12E")
	--13th place patches MK
	local MKPOS13A = v.cachePatch("MKPOS13A")
	local MKPOS13B = v.cachePatch("MKPOS13B")
	local MKPOS13C = v.cachePatch("MKPOS13C")
	local MKPOS13D = v.cachePatch("MKPOS13D")
	local MKPOS13E = v.cachePatch("MKPOS13E")
	--14th place patches MK
	local MKPOS14A = v.cachePatch("MKPOS14A")
	local MKPOS14B = v.cachePatch("MKPOS14B")
	local MKPOS14C = v.cachePatch("MKPOS14C")
	local MKPOS14D = v.cachePatch("MKPOS14D")
	local MKPOS14E = v.cachePatch("MKPOS14E")
	--15th place patches MK
	local MKPOS15A = v.cachePatch("MKPOS15A")
	local MKPOS15B = v.cachePatch("MKPOS15B")
	local MKPOS15C = v.cachePatch("MKPOS15C")
	local MKPOS15D = v.cachePatch("MKPOS15D")
	local MKPOS15E = v.cachePatch("MKPOS15E")
	--16th place patches MK
	local MKPOS16A = v.cachePatch("MKPOS16A")
	local MKPOS16B = v.cachePatch("MKPOS16B")
	local MKPOS16C = v.cachePatch("MKPOS16C")
	local MKPOS16D = v.cachePatch("MKPOS16D")
	local MKPOS16E = v.cachePatch("MKPOS16E")
	
	if not (p.splitscreenindex == 0 and gametype == GT_RACE and fkb_hud == true)
		hud.enable("position")
		return 
	end
	hud.disable("position")
	if p.numberpref == 1
		if p.kartstuff[k_position] == 1
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS01A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS01B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS01C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS01D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS01E, placementflags)
			end
		end
		if p.kartstuff[k_position] == 2
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS02A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS02B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS02C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS02D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS02E, placementflags)
			end
		end
		if p.kartstuff[k_position] == 3
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS03A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS03B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS03C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS03D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS03E, placementflags)
			end
		end
		if p.kartstuff[k_position] == 4
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS04A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS04B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS04C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS04D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS04E, placementflags)
			end
		end
		if p.kartstuff[k_position] == 5
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS05A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS05B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS05C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS05D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS05E, placementflags)
			end
		end
		if p.kartstuff[k_position] == 6
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS06A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS06B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS06C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS06D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS06E, placementflags)
			end
		end
		if p.kartstuff[k_position] == 7
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS07A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS07B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS07C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS07D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS07E, placementflags)
			end
		end
		if p.kartstuff[k_position] == 8
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS08A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS08B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS08C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS08D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS08E, placementflags)
			end
		end
		if p.kartstuff[k_position] == 9
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS09A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS09B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS09C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS09D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS09E, placementflags)
			end
		end
		if p.kartstuff[k_position] == 10
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS10A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS10B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS10C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS10D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS10E, placementflags)
			end
		end
		if p.kartstuff[k_position] == 11
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS11A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS11B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS11C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS11D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS11E, placementflags)
			end
		end
		if p.kartstuff[k_position] == 12
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS12A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS12B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS12C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS12D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS12E, placementflags)
			end
		end
		if p.kartstuff[k_position] == 13
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS13A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS13B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS13C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS13D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS13E, placementflags)
			end
		end
		if p.kartstuff[k_position] == 14
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS14A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS14B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS14C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS14D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS14E, placementflags)
			end
		end
		if p.kartstuff[k_position] == 15
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS15A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS15B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS15C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS15D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS15E, placementflags)
			end
		end
		if p.kartstuff[k_position] == 16
			if p.timesinceposchange == 1
				v.draw(xoffset, yoffset, MKPOS16A, placementflags)
			elseif p.timesinceposchange == 2
				v.draw(xoffset, yoffset, MKPOS16B, placementflags)
			elseif p.timesinceposchange == 3
				v.draw(xoffset, yoffset, MKPOS16C, placementflags)
			elseif p.timesinceposchange == 4
				v.draw(xoffset, yoffset, MKPOS16D, placementflags)
			else
				v.draw(xoffset, yoffset, MKPOS16E, placementflags)
			end
		end
	end
end

hud.add(DynPosition, "game")

-------------------------------------------------------------------------------
--
-- New Speedometer: Thanks Dirk for making this reusable
--
-------------------------------------------------------------------------------


local function draw_newspeedometer(v, p)
	if p.spectator
	or splitscreen
		return
	end
	
	if not (p.splitscreenindex == 0 and gametype == GT_RACE and fkb_hud == true)
		hud.enable("speedometer")
		return 
	end
	hud.disable("speedometer")
		
	local speed = CV_FindVar("kartdisplayspeed")
	local convSpeed
	local percent = 62914
		
	if speed.value == 1
		convSpeed = FixedDiv(FixedMul(p.speed, 142371), mapheaderinfo[gamemap].mobj_scale)/FRACUNIT; // 2.172409058
		v.drawKartString(33, 60, convSpeed.." km/h", V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS, "left")
	elseif speed.value == 2
		convSpeed = FixedDiv(FixedMul(p.speed, 88465), mapheaderinfo[gamemap].mobj_scale)/FRACUNIT; // 2.172409058
		v.drawKartString(33, 60, convSpeed.." mph", V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS, "left")
	elseif speed.value == 3
		convSpeed = FixedDiv(p.speed, mapheaderinfo[gamemap].mobj_scale)/FRACUNIT; // 2.172409058
		v.drawKartString(33, 60, convSpeed.." fu/t", V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS, "left")
	-- Moe Mansion-Galaxy support
	elseif speed.value == 4
		if p.mo
			convSpeed = (FixedDiv(p.speed, FixedMul(K_GetKartSpeed(p, false), percent))*100>>FRACBITS)
			v.drawKartString(33, 60, convSpeed.." P", V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS, "left")
		end
	end
end

hud.add(draw_newspeedometer, "game")

-------------------------------------------------------------------------------
--
-- Time Deltas: How far ahead/behind are you?
-- Jana Sol
-------------------------------------------------------------------------------

local function FKB_TimeDeltas(v, p)
	if p.spectator
	or splitscreen
		return
	end
	if not (p.splitscreenindex == 0 and gametype == GT_RACE and fkb_hud == true)
		return 
	end
	if leveltime < 7*TICRATE then return end
	if p.deltadispticks > 0
		local firsttextflags
		local textflags
		local dominatingtextflags
		local destroyedtextflags
		if p.deltadispticks % 7 == 0
			firsttextflags = V_YELLOWMAP|V_80TRANS
			textflags = V_BLUEMAP|V_80TRANS
			dominatingtextflags = V_GREENMAP|V_80TRANS
			destroyedtextflags = V_REDMAP|V_80TRANS
		elseif p.deltadispticks % 7 == 6
			firsttextflags = V_YELLOWMAP|V_60TRANS
			textflags = V_BLUEMAP|V_60TRANS
			dominatingtextflags = V_GREENMAP|V_60TRANS
			destroyedtextflags = V_REDMAP|V_60TRANS
		elseif p.deltadispticks % 7 == 5
			firsttextflags = V_YELLOWMAP|V_30TRANS
			textflags = V_BLUEMAP|V_30TRANS
			dominatingtextflags = V_GREENMAP|V_30TRANS
			destroyedtextflags = V_REDMAP|V_30TRANS
		elseif p.deltadispticks % 7 == 4
			firsttextflags = V_YELLOWMAP
			textflags = V_BLUEMAP
			dominatingtextflags = V_GREENMAP
			destroyedtextflags = V_REDMAP
		elseif p.deltadispticks % 7 == 3
			firsttextflags = V_YELLOWMAP
			textflags = V_BLUEMAP
			dominatingtextflags = V_GREENMAP
			destroyedtextflags = V_REDMAP
		elseif p.deltadispticks % 7 == 2
			firsttextflags = V_YELLOWMAP|V_30TRANS
			textflags = V_BLUEMAP|V_30TRANS
			dominatingtextflags = V_GREENMAP|V_30TRANS
			destroyedtextflags = V_REDMAP|V_30TRANS
		elseif p.deltadispticks % 7 == 1
			firsttextflags = V_YELLOWMAP|V_60TRANS
			textflags = V_BLUEMAP|V_60TRANS
			dominatingtextflags = V_GREENMAP|V_60TRANS
			destroyedtextflags = V_REDMAP|V_60TRANS
		end
		if p.kartstuff[k_position] == 1
			v.delminutes = p.timedelta/(60*TICRATE)
			v.delseconds = G_TicsToSeconds(p.timedelta)
			v.delmillisecs = G_TicsToCentiseconds(p.timedelta)
			if (v.delminutes < 100)
				if (v.delminutes < 10)
					v.delminutes = "0"..tostring($)
				else
					v.delminutes = tostring($)
				end
				if (v.delseconds < 10)
					v.delseconds = "0"..tostring($)
				else
					v.delseconds = tostring($)
				end
				if (v.delmillisecs < 10)
					v.delmillisecs = "0"..tostring($)
				else
					v.delmillisecs = tostring($)
				end
			end
			if p.lapdelta
				v.drawString(160, 100, "-"..v.delminutes.."."..v.delseconds.."."..v.delmillisecs.." +"..p.lapdelta.." LAPS", dominatingtextflags, "center")
			else
				v.drawString(160, 100, "-"..v.delminutes.."."..v.delseconds.."."..v.delmillisecs, firsttextflags, "center")
			end
		else
			v.delminutes = p.timedelta/(60*TICRATE)
			v.delseconds = G_TicsToSeconds(p.timedelta)
			v.delmillisecs = G_TicsToCentiseconds(p.timedelta)
			if (v.delminutes < 100)
				if (v.delminutes < 10)
					v.delminutes = "0"..tostring($)
				else
					v.delminutes = tostring($)
				end
				if (v.delseconds < 10)
					v.delseconds = "0"..tostring($)
				else
					v.delseconds = tostring($)
				end
				if (v.delmillisecs < 10)
					v.delmillisecs = "0"..tostring($)
				else
					v.delmillisecs = tostring($)
				end
			end
			if p.lapdelta
				v.drawString(160, 100, "+"..v.delminutes.."."..v.delseconds.."."..v.delmillisecs.." +"..p.lapdelta.." LAPS", destroyedtextflags, "center")
			else
				v.drawString(160, 100, "+"..v.delminutes.."."..v.delseconds.."."..v.delmillisecs, textflags, "center")
			end
		end
	end
end

hud.add(FKB_TimeDeltas, "game")

-------------------------------------------------------------------------------
--
-- New Lap Counter: Thanks Dirk for making this reusable
--
-------------------------------------------------------------------------------

local function draw_newgametype(v, p)
	if p.spectator
		return
	end
	if not (p.splitscreenindex == 0 and gametype == GT_RACE and fkb_hud == true)
		hud.enable("gametypeinfo")
		return 
	end
	hud.disable("gametypeinfo")
	
	local lapflags = V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS	
		
	local checklaps = CV_FindVar("numlaps")
		
	
	local posx //Draw at x coordinates
	local posy //Draw at y coordinates
	
	local icon //Draw banner for lap or section race
	
	local picx //Draw banner at x coordinates
	local picy //Draw banner at y coordinates
	
	local align
	
	local actualposx //Draw timer and x combined
	local actualpicx //Draw timer and x combined
	
	//Let's set our local variables according to the splitscreen, shall we?

	if splitscreen
	else
		if G_RaceGametype()
			posx = 241 --42
			--actualposx = posx-p.displayscroll
		else
			posx = 56
			--actualposx = posx-p.displayscroll
		end
		icon = v.cachePatch("K_STLAPW")
		posy = 28
		picx = 208
		picy = 25
		lapflags = V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS
	end
	
	//Draw the HUD in
	-- Race --
	if G_RaceGametype()
		//If we're playing alone or in 2P Split-screen
		if splitscreen <= 1
		
			v.draw(picx, picy, icon, lapflags)
		
			if (p.exiting)
				v.drawKartString(posx, posy, "FIN", lapflags)
				--V_DrawKartString(LAPS_X+33, LAPS_Y+3, V_HUDTRANS|splitflags, "FIN");
			else
				if p.laps >= 9
					v.drawKartString(posx, posy, "  ".."/"..checklaps.value, lapflags)
					if p.kartstuff[k_lapanimation] > 1
						if (leveltime % 16 <= 8)
							v.drawKartString(posx, posy, p.laps+1, lapflags)
						end
					elseif p.kartstuff[k_lapanimation] == 0
						v.drawKartString(posx, posy, p.laps+1, lapflags)
					end
				else
					v.drawKartString(posx, posy, " ".."/"..checklaps.value, lapflags)
					if p.kartstuff[k_lapanimation] > 1
						if (leveltime % 16 <= 8)
							v.drawKartString(posx, posy, p.laps+1, lapflags)
						end
					elseif p.kartstuff[k_lapanimation] == 0
						v.drawKartString(posx, posy, p.laps+1, lapflags)
					end
				end
			end
		end
	end
end

hud.add(draw_newgametype, "game")

-------------------------------------------------------------------------------
--
-- New Timer: Thanks Dirk for making this reusable
--
-------------------------------------------------------------------------------

local function draw_newtime(v, p)
	if not (p.splitscreenindex == 0 and gametype == GT_RACE and fkb_hud == true)
		hud.enable("time")
		return 
	end
	local timeflags = V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS
	hud.disable("time")
	v.hudminutes = p.realtime/(60*TICRATE)
	v.hudseconds = G_TicsToSeconds(p.realtime)
	v.hudmillisecs = G_TicsToCentiseconds(p.realtime)
	
	local checklaps = CV_FindVar("numlaps")
				
	v.draw(172, 9, v.cachePatch("K_STTIMW"), timeflags)
		
	if p.lapsaved == false or p.spectator
		if (v.hudminutes < 100)
				
			// Minutes
			if (v.hudminutes < 10)
				v.drawKartString(205, 12, "0", timeflags)
				v.drawKartString(217, 12, v.hudminutes, timeflags)
			else
				v.drawKartString(205, 12, v.hudminutes, timeflags)
			end
			v.drawKartString(229, 12, "'", timeflags)
			
			// Seconds
			if (v.hudseconds < 10)
				v.drawKartString(241, 12, "0", timeflags)
				v.drawKartString(253, 12, v.hudseconds, timeflags)
			else
				v.drawKartString(241, 12, v.hudseconds, timeflags)
			end
			v.drawKartString(265, 12, '"', timeflags)
			
			//Centiseconds
			if (v.hudmillisecs < 10)
				v.drawKartString(277, 12, "0", timeflags)
				v.drawKartString(289, 12, v.hudmillisecs, timeflags)
			else
				v.drawKartString(277, 12, v.hudmillisecs, timeflags)
			end
		elseif (p.realtime % TICRATE)
			v.drawKartString(205, 12, "99'59"..'\"'.."99", timeflags)
		end
	else
		//We set up the lap time when we actually finish a lap/segment
		v.recminutes = p.lapsavetime/(60*TICRATE)
		v.recseconds = G_TicsToSeconds(p.lapsavetime)
		v.recmillisecs = G_TicsToCentiseconds(p.lapsavetime)
	
		if (leveltime % 16 <= 8)
			if (v.recminutes < 100)
				--v.drawKartString(244+v.displayscroll, 12, "00'00\''00", timeflags)
						
				// Minutes
				if (v.recminutes < 10)
					v.drawKartString(205, 12, "0", timeflags)
					v.drawKartString(217, 12, v.recminutes, timeflags)
				else
					v.drawKartString(205, 12, v.recminutes, timeflags)
				end
				v.drawKartString(229, 12, "'", timeflags)
						
				// Seconds
				if (v.recseconds < 10)
					v.drawKartString(241, 12, "0", timeflags)
					v.drawKartString(253, 12, v.recseconds, timeflags)
				else
					v.drawKartString(241, 12, v.recseconds, timeflags)
				end
					v.drawKartString(265, 12, '"', timeflags)
					
				//Centiseconds
				if (v.recmillisecs < 10)
					v.drawKartString(277, 12, "0", timeflags)
					v.drawKartString(289, 12, v.recmillisecs, timeflags)
				else
					v.drawKartString(277, 12, v.recmillisecs, timeflags)
				end
			end
		else
			v.drawKartString(205, 12, "", timeflags)
		end
	end
end

hud.add(draw_newtime, "game")