-------------------------------------------------------------------------------
--
-- Ramping Up v1.1: What if you slowly got faster each lap? (Thanks Togen for Chaos Drives, lemme butcher that real quick)
-- Technically made by Jana Sol, with some use of Chaos Drives code for better implementation
-------------------------------------------------------------------------------

local fkb_prevmode = 1

local fkb_mode = CV_RegisterVar({
	name = "fkb_mode",
	defaultvalue = "na",
	flags = CV_NETVAR|CV_CALL,
	possiblevalue = {na = -1, short = 1, medium = 2, original = 3, tiny = 4},
	func = function(var)
		if var.value == 1
			COM_BufInsertText(server, "basenumlaps 15")
			if gamestate == GS_LEVEL
				COM_BufInsertText(server, "exitlevel")
			end
		elseif var.value == 2
			COM_BufInsertText(server, "basenumlaps 30")
			if gamestate == GS_LEVEL
				COM_BufInsertText(server, "exitlevel")
			end
		elseif var.value == 3
			COM_BufInsertText(server, "basenumlaps 50")
			if gamestate == GS_LEVEL
				COM_BufInsertText(server, "exitlevel")
			end
		elseif var.value == 4
			COM_BufInsertText(server, "basenumlaps 8")
			if gamestate == GS_LEVEL
				COM_BufInsertText(server, "exitlevel")
			end
		end
	end
})

addHook("MapLoad", do
	local kartcc = CV_FindVar("kartspeed")
	if fkb_mode.value == -1
		COM_BufInsertText(server, "fkb_mode short")
	end
	--print(kartcc.value)
	if fkb_mode.value == 0
		chatprint("\137<Cute Sol-Bot Girl> \130Tails Mode is enabled. Many features have been turned off to reduce the chaos. Contact TPS for more info about Tails Mode.", true)
	elseif fkb_mode.value == 3
		if kartcc.value == 1
			chatprint("\137<Cute Sol-Bot Girl> \130Ramping up! You'll be going from Normal Speed to Master Speed this race!", true)
		elseif kartcc.value == 0
			chatprint("\137<Cute Sol-Bot Girl> \130Ramping up! You'll be going from Easy Speed to Expert Speed this race!", true)
		elseif kartcc.value == 2
			chatprint("\137<Cute Sol-Bot Girl> \130Ramping up! You'll be going from Hard Speed to Master+ Speed this race!", true)
		end
	else
		if kartcc.value == 1
			chatprint("\137<Cute Sol-Bot Girl> \130Ramping up! You'll be going from Normal Speed to Expert Speed this race!", true)
		elseif kartcc.value == 0
			chatprint("\137<Cute Sol-Bot Girl> \130Ramping up! You'll be going from Easy Speed to Hard Speed this race!", true)
		elseif kartcc.value == 2
			chatprint("\137<Cute Sol-Bot Girl> \130Ramping up! You'll be going from Hard Speed to Master Speed this race!", true)
		end
	end
end)

addHook("ThinkFrame", do
	for p in players.iterate do
		if p.laps > 0
			if fkb_mode.value == 1 -- the short game
				local g_cc = 56320 + (12288 * gamespeed)
				local shiftby = 14
				local truespeed = FixedMul((150 + p.kartspeed*2)<<shiftby, g_cc)
				local desiredspeed = FixedMul((150 + (p.kartspeed + p.laps)*2)<<shiftby, g_cc)
				local speeddiff = FixedDiv(desiredspeed, truespeed)
			
				local trueaccel = 32 + (2 * (9 - p.kartspeed))
				local desiredaccel = 32 + (2 * ((9 - p.kartspeed) + p.laps))
				local acceldiff = FixedDiv(desiredaccel, trueaccel)
				
				p.kartstuff[k_accelboost] = FixedMul($, acceldiff) + (acceldiff-FRACUNIT)
				p.kartstuff[k_boostpower] = FixedMul($, speeddiff) + (speeddiff-FRACUNIT)
				
			elseif fkb_mode.value == 2 -- the medium game
				local g_cc = 56320 + (12288 * gamespeed)
				local shiftby = 14
				local truespeed = FixedMul((150 + p.kartspeed*1)<<shiftby, g_cc)
				local desiredspeed = FixedMul((150 + (p.kartspeed + p.laps)*1)<<shiftby, g_cc)
				local speeddiff = FixedDiv(desiredspeed, truespeed)
			
				local trueaccel = 32 + (1 * (9 - p.kartspeed))
				local desiredaccel = 32 + (1 * ((9 - p.kartspeed) + p.laps))
				local acceldiff = FixedDiv(desiredaccel, trueaccel)
				
				p.kartstuff[k_accelboost] = FixedMul($, acceldiff) + (acceldiff-FRACUNIT)
				p.kartstuff[k_boostpower] = FixedMul($, speeddiff) + (speeddiff-FRACUNIT)
				
			elseif fkb_mode.value == 3 -- the way it was meant to be played
				local g_cc = 56320 + (12288 * gamespeed)
				local shiftby = 14
				local truespeed = FixedMul((150 + p.kartspeed*1)<<shiftby, g_cc)
				local desiredspeed = FixedMul((150 + (p.kartspeed + p.laps)*1)<<shiftby, g_cc)
				local speeddiff = FixedDiv(desiredspeed, truespeed)
			
				local trueaccel = 32 + (1 * (9 - p.kartspeed))
				local desiredaccel = 32 + (1 * ((9 - p.kartspeed) + p.laps))
				local acceldiff = FixedDiv(desiredaccel, trueaccel)
				
				p.kartstuff[k_accelboost] = FixedMul($, acceldiff) + (acceldiff-FRACUNIT)
				p.kartstuff[k_boostpower] = FixedMul($, speeddiff) + (speeddiff-FRACUNIT)
				
			elseif fkb_mode.value == 3 -- I hate fun
				local g_cc = 56320 + (12288 * gamespeed)
				local shiftby = 14
				local truespeed = FixedMul((150 + p.kartspeed*1)<<shiftby, g_cc)
				local desiredspeed = FixedMul((150 + (p.kartspeed + p.laps)*1)<<shiftby, g_cc)
				local speeddiff = FixedDiv(desiredspeed, truespeed)
			
				local trueaccel = 32 + (1 * (9 - p.kartspeed))
				local desiredaccel = 32 + (1 * ((9 - p.kartspeed) + p.laps))
				local acceldiff = FixedDiv(desiredaccel, trueaccel)
				
				p.kartstuff[k_accelboost] = FixedMul($, acceldiff) + (acceldiff-FRACUNIT)
				p.kartstuff[k_boostpower] = FixedMul($, speeddiff) + (speeddiff-FRACUNIT)
				
			else -- default settings
				/*local trueaccel = 32 + (1 * (9 - p.kartspeed))
				local desiredaccel = 32 + (1 * p.laps)
				local acceldiff = FixedDiv(desiredaccel, trueaccel)
				
				local g_cc = 56320 + (12288 * gamespeed)
				local shiftby = 14
				local truespeed = FixedMul((150 + p.kartspeed*1)<<shiftby, g_cc)
				local desiredspeed = FixedMul((150 + p.laps*1)<<shiftby, g_cc)
				local speeddiff = FixedDiv(desiredspeed, truespeed)
				
				p.kartstuff[k_accelboost] = FixedMul($, acceldiff) + (acceldiff-FRACUNIT)
				p.kartstuff[k_boostpower] = FixedMul($, speeddiff) + (speeddiff-FRACUNIT)
				*/
			end
		end
	end
end)
/*
			local g_cc = 56320 + (12288 * gamespeed)
			local shiftby = 14
			local truespeed = FixedMul((150 + p.kartspeed*3)<<shiftby, g_cc)
			local desiredspeed = FixedMul((150 + min(p.kartspeed + p.laps), 10)*3)<<shiftby, g_cc)
			local speeddiff = FixedDiv(desiredspeed, truespeed)
			
			local trueaccel = 32 + (4 * 9 - p.kartspeed)
			local desiredaccel = 32 + (4 * min(9 - p.kartspeed + p.laps, 10))
			local acceldiff = FixedDiv(desiredaccel, trueaccel)
			
			local sp = player.kartspeed
			local spm = min(sp + player.cd_run, 10) - player.cd_safeHandicap
			local ac = 9 - sp
			local acm = min(ac + player.cd_swim, 10) - player.cd_safeHandicap
*/
--p.laps
--player.kartstuff[k_accelboost] = FixedMul($, acceldiff) + (acceldiff-FRACUNIT)
--player.kartstuff[k_boostpower] = FixedMul($, speeddiff) + (speeddiff-FRACUNIT)