-------------------------------------------------------------------------------
--
-- The Whirlwind Shield! Fling your enemies far away!
-- A Jana Sol Script
-- Sprites for the shield come from SRB2 and STjr, icon sprites are my own
-------------------------------------------------------------------------------

freeslot(
	"MT_WHIRLWIND",
	"MT_WHIRLWINDFX",
	"SPR_WIND",
	"S_WHIRLWIND",
	"S_WHIRLWIND5",
	"S_WHIRLWIND4",
	"S_WHIRLWIND3",
	"S_WHIRLWIND2",
	"S_WHIRLWIND1",
	"sfx_wdjump",
	"sfx_wirlsg",
	"sfx_wirlls"
)

mobjinfo[MT_WHIRLWIND] = {
	spawnstate = S_WHIRLWIND,
	spawnhealth = 1,
	dispoffset = 1,
	radius = 32*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SCENERY|MF_NOCLIPTHING
}

mobjinfo[MT_WHIRLWINDFX] = {
	spawnstate = S_WHIRLWIND5,
	spawnhealth = 1,
	dispoffset = 1,
	radius = 32*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SCENERY|MF_NOCLIPTHING
}

states[S_WHIRLWIND] = {
	sprite = SPR_WIND,
	frame = TR_TRANS50|FF_ANIMATE|A,
	tics = -1,
	action = nil,
	var1 = 7,
	var2 = 3,
	nextstate = S_NULL
}

states[S_WHIRLWIND5] = {
	sprite = SPR_WIND,
	frame = TR_TRANS50|A,
	tics = 1,
	action = nil,
	var1 = 7,
	var2 = 3,
	nextstate = S_WHIRLWIND4
}

states[S_WHIRLWIND4] = {
	sprite = SPR_WIND,
	frame = TR_TRANS60|B,
	tics = 1,
	action = nil,
	var1 = 7,
	var2 = 3,
	nextstate = S_WHIRLWIND3
}

states[S_WHIRLWIND3] = {
	sprite = SPR_WIND,
	frame = TR_TRANS70|C,
	tics = 1,
	action = nil,
	var1 = 7,
	var2 = 3,
	nextstate = S_WHIRLWIND2
}

states[S_WHIRLWIND2] = {
	sprite = SPR_WIND,
	frame = TR_TRANS80|D,
	tics = 1,
	action = nil,
	var1 = 7,
	var2 = 3,
	nextstate = S_WHIRLWIND1
}

states[S_WHIRLWIND1] = {
	sprite = SPR_WIND,
	frame = TR_TRANS90|E,
	tics = 1,
	action = nil,
	var1 = 7,
	var2 = 3,
	nextstate = S_NULL
}

S_sfx[sfx_wdjump] = {
	singular = false,
	priority = 255,
	flags = SF_X8AWAYSOUND
}

S_sfx[sfx_wirlsg] = {
	singular = false,
	priority = 255,
	flags = 0
}

S_sfx[sfx_wirlls] = {
	singular = false,
	priority = 255,
	flags = SF_X8AWAYSOUND
}

local function getTorn(player, itemId)
	player.tornado = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_WHIRLWIND)
	S_StartSound(player.mo, sfx_wirlsg)
	player.tornado.target = player.mo
end

local function despawnShield(mo)
	mo.target.player.tornadofx = P_SpawnMobj(mo.target.x, mo.target.y, mo.target.z, MT_WHIRLWINDFX)
	
	mo.target.player.tornadofx.fuse = 5
	mo.target.player.tornadofx.scalespeed = FRACUNIT/2
	mo.target.player.tornadofx.destscale = 4*FRACUNIT
	mo.target.player.tornadofx.target = mo.target
	
	P_RemoveMobj(mo)
end

addHook("ShouldSpin", function(player, inflictor, source)
	if player.fkbcrystalshield and player.fkbcrystalshield.valid then return end
	if not player.tornado.valid then return end
	player.kartstuff[k_itemamount] = 0
	player.kartstuff[k_itemtype] = 0
	player.kartstuff[k_invincibilitytimer] = 1
	player.powers[pw_flashing] = 70
	S_StartSound(player.mo, sfx_wirlls)

end)

addHook("ShouldExplode", function(player, inflictor, source)
	if player.fkbcrystalshield and player.fkbcrystalshield.valid then return end
	if not player.tornado.valid then return end
	if source.type == MT_SPBEXPLOSION and source.extravalue1 == 1 then return end
	player.kartstuff[k_itemamount] = 0
	player.kartstuff[k_itemtype] = 0
	player.kartstuff[k_invincibilitytimer] = 1
	player.powers[pw_flashing] = 70
	S_StartSound(player.mo, sfx_wirlls)

end)

addHook("ShouldSquish", function(player, inflictor, source)
	if player.fkbcrystalshield and player.fkbcrystalshield.valid then return end
	if not player.tornado.valid then return end
	player.kartstuff[k_itemamount] = 0
	player.kartstuff[k_itemtype] = 0
	player.kartstuff[k_invincibilitytimer] = 1
	player.powers[pw_flashing] = 70
	S_StartSound(player.mo, sfx_wirlls)

end)

addHook("MobjThinker", function(mo)
    if mo.target.valid
		P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
	else
		P_RemoveMobj(mo)
	end
end, MT_WHIRLWINDFX)

addHook("ThinkFrame", do
	for player in players.iterate do

		if player.kartstuff[k_itemtype] == xItemLib.xItemNamespaces["FKB_TORNADOSHIELD"] and player.playerstate == 0 and not player.tornado.valid
			player.tornado = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_WHIRLWIND)
			S_StartSound(player.mo, sfx_wirlsg)
			player.tornado.target = player.mo
		end
	end
end)

addHook("MobjThinker", function(mo)
	if mo.target.player.playerstate == 1
		P_RemoveMobj(mo)
		return
	end
    if mo.target.player.kartstuff[k_itemtype] == xItemLib.xItemNamespaces["FKB_TORNADOSHIELD"] and mo.target.valid
		P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
		mo.scale = mo.target.scale
	else
		despawnShield(mo)
	end
end, MT_WHIRLWIND)

local function useTorn(player, cmd)
	player.kartstuff[k_itemamount] = $-1
	P_Telekinesis(player, 35*FRACUNIT, 256*FRACUNIT)
	player.mo.momz = 16*FRACUNIT
	S_StartSound(player.mo, sfx_wdjump)
end


xItemLib.func.addItem(
    "FKB_TORNADOSHIELD",
    "Whirlwind Shield",
    "K_ITTORN",
    "K_ISTORN",
    0,
    {10, 10, 10, 10, 10, 10, 10, 10, 10, 10},
    {10, 10},
    getTorn,
    useTorn,
    nil,
    nil,
    nil,
    {0, {SPR_FKIT, 3}},
	true,
    nil,
    nil
)